import {
  generateRandomString
} from "./chunk-TX3I4DOZ.js";
import {
  __async,
  __objRest
} from "./chunk-YAEOLK2W.js";

// src/EventEmitter.ts
var EventEmitter = class {
  constructor(otherWindow, targetOrigin, incomingEvents, outgoingEvents) {
    this.otherWindow = otherWindow;
    this.targetOrigin = targetOrigin;
    this.incomingEvents = incomingEvents;
    this.outgoingEvents = outgoingEvents;
    this.listeners = /* @__PURE__ */ new Map();
    this.otherWindow = otherWindow;
    this.targetOrigin = targetOrigin;
  }
  send(event, data) {
    var _a;
    const result = this.outgoingEvents[event].safeParse(data);
    if (result.success) {
      if (Array.isArray(this.targetOrigin)) {
        this.targetOrigin.forEach((origin) => {
          var _a2;
          (_a2 = this.otherWindow) == null ? void 0 : _a2.postMessage({ event, data }, origin);
        });
      } else {
        (_a = this.otherWindow) == null ? void 0 : _a.postMessage({ event, data }, this.targetOrigin);
      }
    } else {
      console.error("Invalid data for event", event, result.error);
    }
  }
  on(event, callback) {
    const listener = (message) => {
      if (message.data.event === event && this.isTargetOrigin(message.origin)) {
        const data = this.incomingEvents[event].safeParse(message.data.data);
        if (data.success) {
          callback(data.data);
        } else {
          console.error("Invalid data for event", event, data.error);
        }
      }
    };
    const id = generateRandomString();
    this.listeners.set(id, listener);
    window.addEventListener("message", listener);
    return id;
  }
  sendAction({
    event,
    data,
    responseEvent,
    options
  }) {
    var _a;
    const timeoutMs = (_a = options == null ? void 0 : options.timeoutMs) != null ? _a : 7e3;
    return new Promise((resolve, reject) => {
      let interval = void 0;
      const timer = setTimeout(() => {
        reject(
          `Timed out waiting for ${String(responseEvent)} event${(options == null ? void 0 : options.condition) ? ", with condition," : ""} after ${timeoutMs / 1e3}s`
        );
      }, timeoutMs);
      const responseListenerId = this.on(responseEvent, (data2) => {
        if ((options == null ? void 0 : options.condition) && !options.condition(data2)) {
          return;
        }
        if (interval) {
          clearInterval(interval);
        }
        clearTimeout(timer);
        this.off(responseListenerId);
        resolve(data2);
      });
      this.send(event, data);
      if (options == null ? void 0 : options.intervalMs) {
        interval = setInterval(() => this.send(event, data), options == null ? void 0 : options.intervalMs);
      }
    });
  }
  onAction(_a) {
    return __async(this, null, function* () {
      var _b = _a, {
        event,
        options
      } = _b, params = __objRest(_b, [
        "event",
        "options"
      ]);
      var _a2;
      const timeoutMs = (_a2 = options == null ? void 0 : options.timeoutMs) != null ? _a2 : 7e3;
      return new Promise((resolve, reject) => {
        const timer = setTimeout(() => {
          reject(
            `Timed out waiting for ${String(event)} event${(options == null ? void 0 : options.condition) ? ", with condition," : ""} after ${timeoutMs / 1e3}s`
          );
        }, timeoutMs);
        const responseListenerId = this.on(event, (data) => {
          if ((options == null ? void 0 : options.condition) && !options.condition(data)) {
            return;
          }
          if ("callback" in params && params.callback != null) {
            const result = params.callback(data);
            this.send(params.responseEvent, result);
          }
          this.off(responseListenerId);
          clearTimeout(timer);
          resolve(data);
        });
      });
    });
  }
  off(id) {
    const listener = this.listeners.get(id);
    if (listener) {
      window.removeEventListener("message", listener);
      this.listeners.delete(id);
    }
  }
  isTargetOrigin(otherOrigin) {
    if (Array.isArray(this.targetOrigin)) {
      return this.targetOrigin.includes(otherOrigin);
    }
    if (this.targetOrigin === "*") {
      return true;
    }
    return this.targetOrigin === otherOrigin;
  }
};

export {
  EventEmitter
};
//# sourceMappingURL=chunk-DZDN7ZJ7.js.map