import {
  HandshakeParent
} from "./chunk-YFJUB7EJ.js";
import {
  CreatePopupStrategy
} from "./chunk-PUTT3LQC.js";
import {
  urlToOrigin
} from "./chunk-OJ5MRZVB.js";
import {
  __async
} from "./chunk-YAEOLK2W.js";

// src/windows/Popup.ts
var PopupWindow = class _PopupWindow extends HandshakeParent {
  constructor(window2, targetOrigin, options) {
    super(window2, targetOrigin, options);
    this.window = window2;
  }
  static init(url, options) {
    return __async(this, null, function* () {
      const popup = yield createPopup(url, options);
      return new _PopupWindow(
        popup,
        (options == null ? void 0 : options.targetOrigin) || urlToOrigin(url),
        options
      );
    });
  }
  static initSync(url, options) {
    const popup = createPopupSync(url, options);
    return new _PopupWindow(
      popup,
      options.targetOrigin || urlToOrigin(url),
      options
    );
  }
};
function createPopupSync(url, options) {
  const _window = window.open(
    url,
    "popupWindow",
    createPopupString(options.width, options.height, (options == null ? void 0 : options.crossOrigin) || false)
  );
  if (!_window) {
    throw new Error("Failed to open popup window");
  }
  return _window;
}
function createPopup(url, options) {
  const _window = createPopupSync(url, options);
  if (options.awaitToLoad === false) {
    return _window;
  }
  return new Promise((resolve, reject) => {
    _window.onload = () => resolve(_window);
    _window.onerror = () => reject("Failed to load popup window");
  });
}
function createPopupString(width, height, crossOrigin) {
  const createPopupStrategy = new CreatePopupStrategy(crossOrigin);
  const chromeVersion = getChromeVersion();
  const chromeVersionGreaterThan99 = chromeVersion != null && chromeVersion > 99;
  const popupStringBase = isFirefox() || chromeVersionGreaterThan99 ? "popup=true," : "";
  return `${popupStringBase}height=${height},width=${width},left=${createPopupStrategy.getLeft(
    width
  )},top=${createPopupStrategy.getTop(
    height
  )},resizable=yes,scrollbars=yes,toolbar=yes,menubar=true,location=no,directories=no,status=yes`;
}
function getChromeVersion() {
  const raw = navigator.userAgent.match(/Chrom(e|ium)\/([0-9]+)\./);
  return raw ? parseInt(raw[2]) : null;
}
function isFirefox() {
  return navigator.userAgent.toLowerCase().indexOf("firefox") > -1;
}

export {
  PopupWindow
};
//# sourceMappingURL=chunk-HBKEJGNQ.js.map