// src/utils/popupStrategy.ts
var CreatePopupStrategy = class {
  constructor(crossOrigin) {
    this.createPopupService = crossOrigin ? new CrossOriginPopupService() : new CrossmintPopupService();
  }
  getTop(height) {
    return this.createPopupService.getTop(height);
  }
  getLeft(width) {
    return this.createPopupService.getLeft(width);
  }
};
var CrossOriginPopupService = class {
  getTop(height) {
    return (screen.height - height) / 2;
  }
  getLeft(width) {
    return (screen.width - width) / 2;
  }
};
var CrossmintPopupService = class {
  getTop(height) {
    return (window == null ? void 0 : window.top) != null ? window.top.outerHeight / 2 + window.top.screenY - height / 2 : window.outerHeight / 2 + window.screenY - height / 2;
  }
  getLeft(width) {
    return (window == null ? void 0 : window.top) != null ? window.top.outerWidth / 2 + window.top.screenX - width / 2 : window.outerWidth / 2 + window.screenX - width / 2;
  }
};

export {
  CreatePopupStrategy
};
//# sourceMappingURL=chunk-PUTT3LQC.js.map