import {
  HandshakeParent
} from "./chunk-YFJUB7EJ.js";
import {
  urlToOrigin
} from "./chunk-OJ5MRZVB.js";
import {
  __async
} from "./chunk-YAEOLK2W.js";

// src/windows/NewTab.ts
var NewTabWindow = class _NewTabWindow extends HandshakeParent {
  constructor(window2, targetOrigin, options) {
    super(window2, targetOrigin, options);
    this.window = window2;
  }
  static init(url, options) {
    return __async(this, null, function* () {
      const popup = yield createNewTab(url, options);
      return new _NewTabWindow(
        popup,
        (options == null ? void 0 : options.targetOrigin) || urlToOrigin(url),
        options
      );
    });
  }
  static initSync(url, options) {
    const popup = createNewTabSync(url);
    return new _NewTabWindow(
      popup,
      options.targetOrigin || urlToOrigin(url),
      options
    );
  }
};
function createNewTabSync(url) {
  const _window = window.open(url, "_blank");
  if (!_window) {
    throw new Error("Failed to open new tab window");
  }
  return _window;
}
function createNewTab(url, options) {
  const _window = createNewTabSync(url);
  if (options.awaitToLoad === false) {
    return _window;
  }
  return new Promise((resolve, reject) => {
    _window.onload = () => resolve(_window);
    _window.onerror = () => reject("Failed to load new tab window");
  });
}

export {
  NewTabWindow
};
//# sourceMappingURL=chunk-QPSLJS7J.js.map