import {
  HandshakeParent
} from "./chunk-YFJUB7EJ.js";
import {
  urlToOrigin
} from "./chunk-OJ5MRZVB.js";
import {
  __async
} from "./chunk-YAEOLK2W.js";

// src/windows/IFrame.ts
var IFrameWindow = class _IFrameWindow extends HandshakeParent {
  constructor(iframe, targetOrigin, options) {
    const contentWindow = iframe.contentWindow;
    if (!contentWindow) {
      throw new Error("IFrame must have a contentWindow");
    }
    super(contentWindow, targetOrigin, options);
    this.iframe = iframe;
  }
  static init(urlOrExistingIframe, options) {
    return __async(this, null, function* () {
      const iframe = typeof urlOrExistingIframe === "string" ? yield createIFrame(urlOrExistingIframe) : urlOrExistingIframe;
      const targetOrigin = (options == null ? void 0 : options.targetOrigin) || urlToOrigin(iframe.src);
      return new _IFrameWindow(iframe, targetOrigin, options);
    });
  }
  static initExistingIFrame(iframe, options) {
    const targetOrigin = (options == null ? void 0 : options.targetOrigin) || urlToOrigin(iframe.src);
    return new _IFrameWindow(iframe, targetOrigin, options);
  }
};
function createIFrame(url) {
  return __async(this, null, function* () {
    const iframe = document.createElement("iframe");
    iframe.src = url;
    return new Promise((resolve, reject) => {
      iframe.onload = () => resolve(iframe);
      iframe.onerror = () => reject("Failed to load iframe content");
      document.body.appendChild(iframe);
    });
  });
}

export {
  IFrameWindow
};
//# sourceMappingURL=chunk-TVPH6XEQ.js.map