"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkUCRH4BLIcjs = require('./chunk-UCRH4BLI.cjs');


var _chunkHFAXUDQTcjs = require('./chunk-HFAXUDQT.cjs');





var _chunkS42RPI4Jcjs = require('./chunk-S42RPI4J.cjs');

// src/handshake/index.ts
var _zod = require('zod');

// src/handshake/Parent.ts
var HandshakeParent = class extends _chunkUCRH4BLIcjs.EventEmitter {
  constructor(otherWindow, targetOrigin, options) {
    const mergedIncomingEvents = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, options == null ? void 0 : options.incomingEvents), HANDSHAKE_EVENTS.fromChild);
    const mergedOutgoingEvents = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, options == null ? void 0 : options.outgoingEvents), HANDSHAKE_EVENTS.fromParent);
    super(otherWindow, targetOrigin, mergedIncomingEvents, mergedOutgoingEvents);
    this.isConnected = false;
    this.handshakeOptions = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, DEFAULT_HANDSHAKE_OPTIONS), options == null ? void 0 : options.handshakeOptions);
    this.targetOrigin = targetOrigin;
  }
  handshakeWithChild() {
    return _chunkS42RPI4Jcjs.__async.call(void 0, this, null, function* () {
      if (this.isConnected) {
        console.log("[server] Already connected to child");
        return;
      }
      const requestVerificationId = _chunkHFAXUDQTcjs.generateRandomString.call(void 0, );
      yield this._sendAction({
        event: "handshakeRequest",
        data: { requestVerificationId },
        responseEvent: "handshakeResponse",
        options: {
          timeoutMs: this.handshakeOptions.timeoutMs,
          intervalMs: this.handshakeOptions.intervalMs,
          condition: (data) => data.requestVerificationId === requestVerificationId
        }
      });
      this._send("handshakeComplete", {
        requestVerificationId
      });
      this.isConnected = true;
    });
  }
  // Wrap EventEmitter methods, adding handshake event types
  _send(event, data) {
    return super.send(event, data);
  }
  _sendAction(args) {
    return super.sendAction(_chunkS42RPI4Jcjs.__spreadProps.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, args), {
      options: args.options
      // Fixes weird TS behavior when compiling
    }));
  }
};

// src/handshake/index.ts
var DEFAULT_HANDSHAKE_OPTIONS = {
  timeoutMs: 1e4,
  intervalMs: 100
};
var HANDSHAKE_EVENTS = {
  fromChild: {
    handshakeResponse: _zod.z.object({
      requestVerificationId: _zod.z.string()
    })
  },
  fromParent: {
    handshakeRequest: _zod.z.object({
      requestVerificationId: _zod.z.string()
    }),
    handshakeComplete: _zod.z.object({
      requestVerificationId: _zod.z.string()
    })
  }
};

// src/handshake/Child.ts
var HandshakeChild = class _HandshakeChild extends _chunkUCRH4BLIcjs.EventEmitter {
  constructor(otherWindow, targetOrigin, options) {
    const mergedIncomingEvents = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, options == null ? void 0 : options.incomingEvents), HANDSHAKE_EVENTS.fromParent);
    const mergedOutgoingEvents = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, options == null ? void 0 : options.outgoingEvents), HANDSHAKE_EVENTS.fromChild);
    super(otherWindow, targetOrigin, mergedIncomingEvents, mergedOutgoingEvents);
    this.isConnected = false;
    this.handshakeOptions = _chunkS42RPI4Jcjs.__spreadValues.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, DEFAULT_HANDSHAKE_OPTIONS), options == null ? void 0 : options.handshakeOptions);
  }
  handshakeWithParent() {
    return _chunkS42RPI4Jcjs.__async.call(void 0, this, null, function* () {
      if (this.isConnected) {
        console.log("[client] Already connected to parent");
        return;
      }
      const { requestVerificationId } = yield this._onAction({
        event: "handshakeRequest",
        callback: (data) => data,
        responseEvent: "handshakeResponse",
        options: {
          timeoutMs: this.handshakeOptions.timeoutMs
        }
      });
      yield this._onAction({
        event: "handshakeComplete",
        options: {
          timeoutMs: this.handshakeOptions.timeoutMs,
          condition: (data) => data.requestVerificationId === requestVerificationId
        }
      });
      this.isConnected = true;
    });
  }
  // Wrap EventEmitter methods, adding handshake event types
  _onAction(args) {
    return _chunkS42RPI4Jcjs.__async.call(void 0, this, null, function* () {
      return _chunkS42RPI4Jcjs.__superGet.call(void 0, _HandshakeChild.prototype, this, "onAction").call(this, _chunkS42RPI4Jcjs.__spreadProps.call(void 0, _chunkS42RPI4Jcjs.__spreadValues.call(void 0, {}, args), {
        options: args.options
        // Fixes weird TS behavior when compiling
      }));
    });
  }
};






exports.HandshakeChild = HandshakeChild; exports.HandshakeParent = HandshakeParent; exports.DEFAULT_HANDSHAKE_OPTIONS = DEFAULT_HANDSHAKE_OPTIONS; exports.HANDSHAKE_EVENTS = HANDSHAKE_EVENTS;
//# sourceMappingURL=chunk-XII7WBIO.cjs.map